!========================================
! Copyright  2001 by Sand & Associates
!========================================
  MEMBER()

 OMIT('*endomit*',_C55_)
_ABCDllMode_    EQUATE(0)
_ABCLinkMode_   EQUATE(1)
 *endomit*

  INCLUDE('LoadLib.inc')

  MAP
   MODULE('Win32Api')
    LoadLibrary(*CSTRING pszModuleFileName), UNSIGNED, PASCAL, RAW, NAME('LoadLibraryA')
    FreeLibrary(UNSIGNED hModule), LONG, PASCAL, PROC
    GetModuleHandle(*CSTRING pszModuleName), UNSIGNED, PASCAL, RAW, NAME('GetModuleHandleA')
    GetProcAddress(UNSIGNED hModule,    | Handle returned by LoadLibrary()
                   *CSTRING pszProcName | Name of the procedure
                  ), LONG, PASCAL, RAW

    IsBadCodePtr(LONG lpfn), BOOL, PASCAL

    GetLastError(), ULONG, PASCAL, NAME('GetLastError')
   END

  END

!=====================================================================
! GetLastAPIError()
!=====================================================================
LoadLibClass.GetLastAPIError PROCEDURE()
  CODE
  RETURN GetLastError()

!=====================================================================
! LlcLoadLibrary()
!=====================================================================
LoadLibClass.LlcLoadLibrary     PROCEDURE(STRING sModuleFileName, |
                                          UNSIGNED LoadMethod = Method:LoadLibrary )
RetCode             LONG,AUTO
  CODE
  ASSERT(_WIDTH32_)

  RetCode = 1
  IF NOT SELF.LibraryLoaded()
    SELF.szModuleFileName &= NEW(CSTRING(LEN(CLIP(sModuleFileName))+1))
    ASSERT(NOT SELF.szModuleFileName &= NULL)
    IF NOT SELF.szModuleFileName &= NULL
      SELF.szModuleFileName = CLIP(sModuleFileName)

      SELF.LoadMethod = CHOOSE(LoadMethod < Method:Last AND LoadMethod > 0, |
                               LoadMethod, |
                               Method:LoadLibrary)

      EXECUTE SELF.LoadMethod
        SELF.hModule = LoadLibrary(SELF.szModuleFileName)
        SELF.hModule = GetModuleHandle(SELF.szModuleFileName)
      END

    END

    IF SELF.LibraryLoaded()
      RetCode = SUCCESS
    ELSE
      SELF.OnLoadLibraryFailure()
    END
  END
  RETURN RetCode


!=====================================================================
! OnLoadLibraryFailure()
!=====================================================================
LoadLibClass.OnLoadLibraryFailure         PROCEDURE()
  CODE
  SELF.LastError = GetLastError()
  RETURN


!=====================================================================
! LlcGetProcAddress()
!=====================================================================
LoadLibClass.LlcGetProcAddress             PROCEDURE(STRING sProcedureName)
lpProcedure     LONG,AUTO

  CODE
  
  ASSERT( LEN(sProcedureName)+1 < SIZE(SELF.szProcedureName)) !'GetProcAddress() szProcedureName is too small ' )

  IF SELF.LibraryLoaded()
    SELF.szProcedureName = CLIP(sProcedureName)
    lpProcedure = GetProcAddress(SELF.hModule, SELF.szProcedureName)
    IF IsBadCodePtr(lpProcedure)
      lpProcedure = 0
      SELF.OnGetProcAddressFailure()
    END
  ELSE 
    ASSERT(False) !'GetProcAddress("'&SELF.szProcedureName&'") failed, module not loaded'
    lpProcedure = 0
  END
  RETURN lpProcedure

!=====================================================================
! OnGetProcAddressFailure()
!=====================================================================
LoadLibClass.OnGetProcAddressFailure      PROCEDURE()

  CODE
  SELF.LastError = GetLastError()

  RETURN


!=====================================================================
! LlcFreeLibrary()
!=====================================================================
LoadLibClass.LlcFreeLibrary PROCEDURE()
RetVal  LONG,AUTO

  CODE
  DISPOSE(SELF.szModuleFileName)
  RetVal = SUCCESS

  IF SELF.LibraryLoaded()
    IF SELF.LoadMethod = Method:LoadLibrary
      IF NOT FreeLibrary(SELF.hModule)
        RetVal = 1
        SELF.LastError = GetLastError()
      END
    END
    SELF.hModule = 0
  END

  RETURN RetVal


!=====================================================================
! LibraryLoaded()
!=====================================================================
LoadLibClass.LibraryLoaded          PROCEDURE()
  CODE
  RETURN CHOOSE(SELF.hModule)


!=====================================================================
! Destruct()
!=====================================================================
LoadLibClass.Destruct PROCEDURE()
  CODE
  SELF.LlcFreeLibrary()
  RETURN
